# Prevent stripping
%global __spec_install_post /usr/lib/rpm/brp-compress
# Turn off debuginfo package
%global debug_package %{nil}

Summary:	A stand alone memory test for i386 architecture systems
Name:		memtest86+
Version:	5.01
Release:	%mkrel 11
License:	GPL
Source0:	http://www.memtest.org/download/%{version}/%{name}-%{version}.tar.gz
Source3:  20_memtest86+
Source5:  memtest86+.conf
# Fedora patches:
Patch0:			memtest86+-5.01-no-scp.patch
# patches to get memtest86+ working with gcc-4.7.2 or later + PCI scan fix
# these patches were taken from Mageia
# upstream report containing link to the patches:
# http://forum.canardpc.com/threads/83443-Memtest86-V5.01-crashes-with-gcc-4.7.2-or-later
Patch1:			memtest86+-5.01-no-optimization.patch
Patch2:			memtest86+-5.01-compile-fix.patch
Patch3:			memtest86+-5.01-crash-fix.patch
Patch4:			memtest86+-5.01-fgnu89-inline.patch
URL:		http://www.memtest.org
Group:		System/Kernel and hardware
BuildRequires:	dev86
Requires(post):	drakxtools-backend
Requires(preun):	drakxtools-backend
ExclusiveArch:	%{ix86} x86_64
Obsoletes:	memtest86
Provides:	memtest86
Conflicts:	grub2-common < 2.02-0.git10101.2
# Also conflict main packages for system upgrades from Mga5 which did not have -common
Conflicts:	grub2-efi < 2.02-0.git10101.2
Conflicts:	grub2 < 2.02-0.git10101.2

%description
Memtest86+ is a thorough stand-alone memory test for x86 and x86_64 
architecture computers. BIOS based memory tests are only a quick 
check and often miss many of the failures that are detected by 
Memtest86+.

The ELF version should be used for booting from grub,
and avoids the following errors:
"Error 7: Loading below 1MB is not supported"
"Error 13: Invalid or unsupported executable format"
"Error 28: Selected item cannot fit into memory"

%prep
%setup -q
%autopatch -p1
#sed -i -e's,0x10000,0x100000,' memtest.lds
%ifarch x86_64
sed -i -e's,$(LD) -s -T memtest.lds,$(LD) -s -T memtest.lds -z max-page-size=0x1000,' Makefile
%endif

%build
make

%install
mkdir -p %{buildroot}/boot
mkdir -p %{buildroot}/%{_sysconfdir}/grub.d

# the ELF (memtest) version.
install -m644 memtest %{buildroot}/boot/elf-%{name}-%{version}

# the floppy (memtest.bin) version.
install -m644 memtest.bin -D %{buildroot}/boot/memtest.bin

install -D -m 755 %{SOURCE3} %{buildroot}/%{_sysconfdir}/grub.d/

# install configuration file
install -Dpm 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/memtest86+.conf

%post
if [ -x /usr/sbin/bootloader-config ]; then
    /usr/sbin/bootloader-config --action add-entry --label memtest --image /boot/memtest.bin || :
fi

%preun
if [ -x /usr/sbin/bootloader-config ]; then
    /usr/sbin/bootloader-config --action remove-entry --label memtest || :
fi

%files
%doc FAQ
%config(noreplace) %{_sysconfdir}/memtest86+.conf
%{_sysconfdir}/grub.d/20_memtest86+
/boot/memtest.bin
/boot/elf-%{name}-%{version}


%changelog
* Tue May 31 2016 tv <tv> 5.01-11.mga6
+ Revision: 1019570
- ignore %%post/preun errogs (eg, when boot loader is not yet configured, mga#18494)
- rename & sync grub2 config with FC

* Sat May 14 2016 luigiwalser <luigiwalser> 5.01-10.mga6
+ Revision: 1015533
- change requires to req(post) and req(preun) on only drakxtools-backend

  + tv <tv>
    - use FC patch for gcc build fix

* Tue Mar 29 2016 barjac <barjac> 5.01-9.mga6
+ Revision: 996195
- fix conflicts for upgrades from Mga5

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

* Mon Nov 16 2015 barjac <barjac> 5.01-7.mga6
+ Revision: 903490
- move 93_memtest here from grub2 - Mga#15914
- conflict earlier grub2-common

* Sun Sep 20 2015 tv <tv> 5.01-6.mga6
+ Revision: 881728
- reorder installation (more similar to FC)
- package ELF version too
- disable stripping & debuginfo
- fixes from FC:
  o fix memory region to load (rhbz#578966)
  o reduce max-page-size on x86_64 to fit into loader limits (rhbz#620846)
- patch 50: fix build
- sync patches with FC

* Wed Jan 08 2014 pterjan <pterjan> 5.01-5.mga5
+ Revision: 565495
- Disable gcc optimisations (and fix build with -O0)

* Fri Jan 03 2014 dmorgan <dmorgan> 5.01-4.mga4
+ Revision: 564084
- Disable parallel build for the moment

* Thu Dec 12 2013 pterjan <pterjan> 5.01-3.mga4
+ Revision: 556502
- Fix access outside an array

* Mon Oct 21 2013 umeabot <umeabot> 5.01-2.mga4
+ Revision: 539723
- Mageia 4 Mass Rebuild

* Tue Oct 08 2013 dams <dams> 5.01-1.mga4
+ Revision: 492825
- new version 5.01

* Sat Jan 12 2013 umeabot <umeabot> 4.20-3.mga3
+ Revision: 359946
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 04 2012 dams <dams> 4.20-2.mga3
+ Revision: 326513
- add a patch to fix 7th test failure (from fedora #805813)
- clean spec file
- update %%description

* Thu Jan 27 2011 erwan <erwan> 4.20-1.mga1
+ Revision: 42181
- Fixing source path
- New release 4.20
- imported package memtest86+

